# ETFStats

[//]: # (CLASS:IntrinioSDK::ETFStats)

[//]: # (KIND:object)

## Properties

[//]: # (START_DEFINITION)

Name | Type | Description
------------ | ------------- | -------------
**date** | [**Date**](Date.md) |  &nbsp;
**net_asset_value** | **Numeric** | The net asset value (NAV &#x3D; Total Assets - Total Liabilities) &nbsp;
**beta_vs_spy** | **Numeric** | Volatility this ETF is versus the SPY ETF &nbsp;
**trailing_one_month_return_split_and_dividend** | **Numeric** | Trailing one month return including dividends &nbsp;
**trailing_one_month_return_split_only** | **Numeric** | Trailing one month return excluding dividends &nbsp;
**trailing_one_year_return_split_and_dividend** | **Numeric** | Trailing one year return including dividends &nbsp;
**trailing_one_year_return_split_only** | **Numeric** | Trailing one year return excluding dividends &nbsp;
**trailing_one_year_volatility_annualized** | **Numeric** | Annualized standard deviation of daily price returns over trailing 252 trading days &nbsp;
**trailing_three_year_annualized_return_split_and_dividend** | **Numeric** | Trailing three year return including dividends &nbsp;
**trailing_three_year_annualized_return_split_only** | **Numeric** | Trailing three year return excluding dividends &nbsp;
**trailing_three_year_volatility_annualized** | **Numeric** | Annualized standard deviation of daily price returns over trailing 756 trading days &nbsp;
**trailing_five_year_annualized_return_split_and_dividend** | **Numeric** | Trailing five year return including dividends &nbsp;
**trailing_five_year_annualized_return_split_only** | **Numeric** | Trailing five year return excluding dividends &nbsp;
**trailing_five_year_volatility_annualized** | **Numeric** | Annualized standard  deviation  of  daily  price  returns  over  trailing 1260 trading days &nbsp;
**trailing_ten_year_annualized_return_split_and_dividend** | **Numeric** | Trailing ten year return including dividends &nbsp;
**trailing_ten_year_annualized_return_split_only** | **Numeric** | Trailing ten year return excluding dividends &nbsp;
**inception_annualized_return_split_and_dividend** | **Numeric** | Annualized return including dividends since inception &nbsp;
**inception_annualized_return_split_only** | **Numeric** | Annualized return excluding dividends since inception &nbsp;
**calendar_year_5_return_split_and_dividend** | **Numeric** | Five years ago calendar year return including dividends &nbsp;
**calendar_year_5_return_split_only** | **Numeric** | Five years ago calendar year return excluding dividends &nbsp;
**calendar_year_4_return_split_and_dividend** | **Numeric** | Four years ago calendar year return including dividends &nbsp;
**calendar_year_4_return_split_only** | **Numeric** | Four years ago calendar year return excluding dividends &nbsp;
**calendar_year_3_return_split_and_dividend** | **Numeric** | Three years ago calendar year return including dividends &nbsp;
**calendar_year_3_return_split_only** | **Numeric** | Three years ago calendar year return excluding dividends &nbsp;
**calendar_year_2_return_split_and_dividend** | **Numeric** | Two years ago calendar year return including dividends &nbsp;
**calendar_year_2_return_split_only** | **Numeric** | Two years ago calendar year return excluding dividends &nbsp;
**calendar_year_1_return_split_and_dividend** | **Numeric** | One year ago calendar year return including dividends &nbsp;
**calendar_year_1_return_split_only** | **Numeric** | One year ago calendar year return excluding dividends &nbsp;
**calendar_year_to_date_return_split_and_dividend** | **Numeric** | Calendar year to date (YTD) return including dividends &nbsp;
**calendar_year_to_date_return_split_only** | **Numeric** | Calendar year to date (YTD) return excluding dividends &nbsp;
**etf** | [**ETFSummary**](ETFSummary.md) |  &nbsp;

[//]: # (END_DEFINITION)


[//]: # (CONTAINED_CLASS:IntrinioSDK::Date)


[//]: # (CONTAINED_CLASS:IntrinioSDK::ETFSummary)


[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


